#!/usr/bin/python
# -*- coding: utf-8 -*-

# GUI
import pygtk
pygtk.require('2.0')
import gtk
import gobject

# Time formatting
from time import gmtime, time, sleep

# math
from math import ceil

import os

import urllib
import md5

# Benutzerklassen
import clJamendo, clPlayer, clDB
from constants import *
import functions

# Gettext - Übersetzung
functions.translation_gettext()
#def _(string):
#    return string

def clear(string):
    if string == None: return string
    string = string.replace("\r", "")
    string = string.replace("\t", "")
    string = string.replace(",", "")
    return string


class MyDialog(gtk.Dialog):
    def __init__(self, caption, toplevel, flags, buttons, image, desc):
            gtk.Dialog.__init__(self, caption, toplevel, flags, buttons)
            img = gtk.Image()
            img.set_from_stock(image, gtk.ICON_SIZE_DIALOG)
            hbox = gtk.HBox()
            self.vbox.pack_start(hbox)
            hbox.pack_start(img)
            hbox.pack_start(gtk.Label(desc))
            self.show_all()

# data
articles = [
    [ "Herribert Müller", "Unter der Sone", "", 1, 1, -1 ],
    [ "Herribert Knaus", "Raus aus der Stadt", "", 2, 2, -1 ],
    [ "Willi Wichtig", "Mein Name sei Herribert", "", 3,3 , -1 ],
    [ "Reiner Riese", "Herribert mal anders", "", 4, 4, -1 ],
    [ "V.v. Goch", "Keinohrmaler", "Herribert am Gatenstrauch", 5, 5,5, 1 ],
    [ "Richard Müller", "Ritalin", "Herribert nimmt's", 6, 6, 2 ]
]


class TreeViewList(gtk.TreeView):

    #   columns
    (
      COLUMN_ARTIST,
      COLUMN_ALBUM,
      COLUMN_TRACKNUM,
      COLUMN_TRACK,
      COLUMN_LICENSE,
      COLUMN_ARTISTID,
      COLUMN_ALBUMID,
      COLUMN_TRACKID,
    ) = range(8)

    def __init__(self):
        # create model
        model = self.__create_model()

        # create tree view
        gtk.TreeView.__init__(self, model)
        self.set_rules_hint(True)
        self.set_rubber_banding(True)
        self.set_show_expanders(True)
        #self.set_reorderable(True)
        self.get_selection().set_mode(gtk.SELECTION_MULTIPLE)#gtk.SELECTION_MULTIPLE
        self.__add_columns(self)

        self.show()

    def get_item(self, path):
        model = self.get_model()
        retIter = model.get_iter(path)
        ret = model.get(retIter, 0, 1, 2, 3, 4, 5, 6, 7)
        return ret
        

    def clear(self):
        model = self.get_model()
        model.clear()


    def add_item(self, item):
        model = self.get_model()
        #articles.append(new_item)
        if item[self.COLUMN_TRACKNUM] != "":
            item[self.COLUMN_TRACKNUM] = "%02d" % int(item[self.COLUMN_TRACKNUM])

        iter = model.append()
        model.set (iter,
            self.COLUMN_ARTIST, item[self.COLUMN_ARTIST],
            self.COLUMN_ALBUM, item[self.COLUMN_ALBUM],
            self.COLUMN_TRACKNUM, item[self.COLUMN_TRACKNUM],
            self.COLUMN_TRACK, item[self.COLUMN_TRACK],
            self.COLUMN_LICENSE, item[self.COLUMN_LICENSE],
            self.COLUMN_ARTISTID, item[self.COLUMN_ARTISTID],
            self.COLUMN_ALBUMID, item[self.COLUMN_ALBUMID],
            self.COLUMN_TRACKID, item[self.COLUMN_TRACKID]
       )

    def __create_model(self):

        # create list store
        model = gtk.ListStore(
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_STRING,
            gobject.TYPE_INT,
            gobject.TYPE_INT,
            gobject.TYPE_INT
       )
       
#        # add items
#        for item in articles:
#            iter = model.append()

#            model.set (iter,
#                  COLUMN_ARTIST, item[COLUMN_ARTIST],
#                  COLUMN_ALBUM, item[COLUMN_ALBUM],
#                  COLUMN_TRACK, item[COLUMN_TRACK]
#           )
        return model


    def __add_columns(self, treeview):

        model = treeview.get_model()

        # artist column
        renderer = gtk.CellRendererText()
        renderer.set_data("column", self.COLUMN_ARTIST)

        column = gtk.TreeViewColumn("Artist", renderer, text=self.COLUMN_ARTIST)
        treeview.append_column(column)
        column.set_sort_column_id(0)
        column.set_resizable(True)

        # album column
        renderer = gtk.CellRendererText()
        renderer.set_data("column", self.COLUMN_ALBUM)

        column = gtk.TreeViewColumn("Album", renderer, text=self.COLUMN_ALBUM)
        treeview.append_column(column)
        column.set_sort_column_id(1)
        column.set_resizable(True)

        # track column
        renderer = gtk.CellRendererText()
        renderer.set_data("column", self.COLUMN_TRACKNUM)

        column = gtk.TreeViewColumn("#", renderer, text=self.COLUMN_TRACKNUM)
        treeview.append_column(column)
        column.set_sort_column_id(2)
        column.set_resizable(True)

        # track column
        renderer = gtk.CellRendererText()
        renderer.set_data("column", self.COLUMN_TRACK)

        column = gtk.TreeViewColumn("Track", renderer, text=self.COLUMN_TRACK)
        treeview.append_column(column)
        column.set_sort_column_id(3)
        column.set_resizable(True)
        
        # license column
        renderer = gtk.CellRendererText()
        renderer.set_data("column", self.COLUMN_LICENSE)

        column = gtk.TreeViewColumn("Lizenz", renderer, text=self.COLUMN_LICENSE)
        treeview.append_column(column)
        column.set_sort_column_id(4)
        column.set_resizable(True)



class Rating(gtk.HBox):
    def __init__(self):
        gtk.HBox.__init__(self)
        self.img=[]
        for img in range(0, 10):
            self.img.append(gtk.Image())
            pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(os.path.join(functions.install_dir(), "images", "star.png"), 16, 16)
            #pixbuf = self.img[img].render_icon(gtk.STOCK_ABOUT, gtk.ICON_SIZE_MENU, detail=None)
            self.img[img].set_from_pixbuf(pixbuf)
            self.pack_start(self.img[img], True, True, 0)
            self.img[img].show()
            
    def set_rating(self, rating):
        for img in self.img:
            img.hide()
            
        rating = int(ceil(float(rating)))
        
        for img in range(0, rating):
            self.img[img].show()

class StatusBar(gtk.HBox):
    def __init__(self, *argv):
        self.statusbars = {}

        gtk.HBox.__init__(self, False)
        
        for item in argv:
            self.statusbars[item] = {'statusbar':gtk.Statusbar()} 
            self.statusbars[item]['conid'] = self.statusbars[item]['statusbar'].get_context_id("Status")
            self.statusbars[item]['msgid'] = self.statusbars[item]['statusbar'].push(self.statusbars[item]['conid'], "")
            if item != argv[len(argv)-1]:
                self.statusbars[item]['statusbar'].set_has_resize_grip(False)
                self.statusbars[item]['sep'] = gtk.VSeparator()
                self.pack_start(self.statusbars[item]['statusbar'], True, True, 0)
                self.pack_start(self.statusbars[item]['sep'], False, False, 0)
                self.statusbars[item]['statusbar'].show()
                self.statusbars[item]['sep'].show()
            else:
                self.statusbars[item]['statusbar'].set_has_resize_grip(True)
                self.pack_start(self.statusbars[item]['statusbar'], True, True, 0)
                self.statusbars[item]['statusbar'].show()
#                self.progressBar = gtk.ProgressBar()
#                self.progressBar.set_size_request(30,5)
#                self.progressBar.hide()
#                self.statusbars[item]['statusbar'].add(self.progressBar)

    def set_text(self, statusbar, text):
        self.statusbars[statusbar]['msgid'] = self.statusbars[statusbar]['statusbar'].push(self.statusbars[statusbar]['conid'], text)

class ResultsPerPageCombo(gtk.ComboBox):
    def __init__(self):
        liststore = gtk.ListStore(gobject.TYPE_STRING)
        gtk.ComboBox.__init__(self,liststore)
        cell = gtk.CellRendererText()
        self.pack_start(cell, True)
        self.add_attribute(cell, 'text', 0)
        self.set_tooltip_text(_("How many results should be shown?"))

        self.cbResultsPerPage = gtk.combo_box_new_text()

        self.modelist = ["10", "20", "30", "40", "50"]
        for mode in self.modelist:
            self.append_text(mode)
        self.set_active(0)

    def set_item(self, mode):
        self.set_active(self.modelist.index(str(mode)))

class OrderCombo(gtk.ComboBox):
    def __init__(self):
        liststore = gtk.ListStore(gobject.TYPE_STRING)
        gtk.ComboBox.__init__(self, liststore)
        cell = gtk.CellRendererText()
        self.pack_start(cell, True)
        self.add_attribute(cell, 'text', 0)
        self.set_tooltip_text(_("Select how to order results"))
        
        self.modelist = ["rating", "ratingweek", "ratingmonth", "date", "downloaded", "listened", "starred", "playlisted"]
        for mode in self.modelist:
            self.append_text(mode)
        self.set_active(1)
        
    def set_item(self, mode):
        self.set_active(self.modelist.index(mode))

class TagsCombo(gtk.ComboBox): #Entry
    def __init__(self):
        liststore = gtk.ListStore(gobject.TYPE_STRING)
        gtk.ComboBox.__init__(self, liststore, ) #Entry
        cell = gtk.CellRendererText()
        self.pack_start(cell, False)
        self.set_wrap_width(5)
        self.set_tooltip_text(_("Select tags to show"))

        self.set_model(liststore)
        self.add_attribute(cell, 'text', 0)     
     
        self.modelist = ["all", "ambient","experimental","instrumental","electro","alternativ","hiphop","guitar","metal","pop","punk","rock","techno","triphop","world","trance","progressive","gothic","hardcore","minimal","funk","dance","psychedelic","8bit"]


        for mode in self.modelist:
            #self.append_text(mode)
            liststore.append([mode])

        self.set_active(0)    
        
    def set_item(self, mode):
        self.set_active(self.modelist.index(mode))

class MouseLabel(gtk.Label):
    def __init__(self,t):
        gtk.Label.__init__(self, t)

        eventbox = gtk.EventBox()
        eventbox.add(self)
        eventbox.add_events (gtk.gdk.BUTTON_RELEASE)
        boat = gtk.gdk.Cursor(gtk.gdk.WATCH)
        eventbox.window.set_cursor(boat)
        eventbox.connect("realize", self.on_realize)

    def on_realize(self, widget):
        print "asd"
    #     self.set_cursor(watch)


class StockButton(gtk.Button):
    def __init__(self, stock, size=gtk.ICON_SIZE_MENU, text=None):
        gtk.Button.__init__(self, text)

        pixbuf = self.render_icon(stock, size, detail=None)
        self.img = gtk.Image()
        self.img.set_from_pixbuf(pixbuf)
        #set_from_stock(stock_id, size)
        self.set_image(self.img)
        
       
        self.tag = None
        
    def setimage(self, stock, size=gtk.ICON_SIZE_MENU):
        pixbuf = self.render_icon(stock, size, detail=None)
        self.img = gtk.Image()
        self.img.set_from_pixbuf(pixbuf)
        self.set_image(self.img)

class ImageButton(gtk.Button):
    def __init__(self, sFile, w, h, text=None):
        gtk.Button.__init__(self, text)

        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(sFile, w, h)
        img = gtk.Image()
        img.set_from_pixbuf(pixbuf)
        #set_from_stock(stock_id, size)
        self.set_image(img)


class AlbumInfo(gtk.Frame):
    def __init__(self, parent, album):
        self.imagewidth = 100
        self.imageheight = 100
        self.album = album
        self.par = parent
        self.over_button = True

        gtk.Frame.__init__(self)
        self.set_label_align(0.5, 0.5)
        self.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.set_size_request(150,160) #(150,160) before controls
        
        # Album
        self.lAlbum = gtk.LinkButton("", str(album['album_name'][:20])) #gtk.Label()
        self.lAlbum.show()
        self.set_label_widget(self.lAlbum)
        self.lAlbum.connect("clicked", self.lAlbum_clicked)
        
        self.hbox = gtk.HBox(homogeneous=False, spacing=0)
        self.vbox = gtk.VBox(homogeneous=False, spacing=0)

        self.eventFrame = gtk.EventBox()
        self.add(self.eventFrame)
        self.eventFrame.add(self.hbox)
        #self.add(self.hbox) #==> eventFrame
        
        self.hbox.pack_start(self.vbox)
        self.vbox.set_size_request(100,150)
        self.hbox.show()
        self.vbox.show()

        # ControlBox        
        self.vbControl = gtk.VBox()
        self.hbox.pack_start(self.vbControl)
        self.vbControl.hide()
        # Play
        self.bControlPlay = StockButton(gtk.STOCK_MEDIA_PLAY)
        self.bControlPlay.set_tooltip_text(_("Append this album on playlist and play it"))
        self.vbControl.pack_start(self.bControlPlay, False, True, 0)
        self.bControlPlay.connect("clicked", self.on_bControlPlay)
        self.bControlPlay.show()
        # Add
        self.bControlAdd = StockButton(gtk.STOCK_ADD)
        self.bControlAdd.set_tooltip_text(_("Append this album on playlist"))
        self.vbControl.pack_start(self.bControlAdd, False, True, 0)
        self.bControlAdd.connect("clicked", self.on_bControlAdd)
        self.bControlAdd.show()
        # Star
        self.bControlStar = ImageButton(os.path.join(functions.install_dir(), "images", "star.png"), 16, 16)
        self.bControlStar.set_tooltip_text(_("Add this album to favorites [not implemented, yet]"))
        self.vbControl.pack_start(self.bControlStar, False, True, 10)
        self.bControlStar.connect("clicked", self.on_bControlStar)
        self.bControlStar.show()
        # Event-Box
        self.eventFrame.set_above_child(False) # ???
        self.eventFrame.add_events (gtk.gdk.ENTER_NOTIFY_MASK)
        self.eventFrame.add_events (gtk.gdk.LEAVE_NOTIFY_MASK)
        self.eventFrame.connect("enter-notify-event", self.show_vbControl)
        self.eventFrame.connect("leave-notify-event", self.hide_vbControl)
        self.eventFrame.connect("button_release_event", self.image_clicked, album)
        self.eventFrame.show()
        
        # Image
        md5hash = md5.new(album['album_image']).hexdigest()
        imagepath = os.path.join(parent.home, "images", md5hash)
        #print album['album_image']
        if not os.path.exists(imagepath):
            if self.par.debug_extreme:
                print _("Trying to get album cover from %s[...]") % album['album_image']
            try:
                urllib.urlretrieve(album['album_image'], imagepath)
            except IOError:
                print _("Could not get album cover from jamendo")
                return None
        else:
            pass
            if self.par.debug_extreme:
                print _("Got cover from HD")
        self.image = gtk.Image()
        self.vbox.pack_start(self.image, False, False, 0)#, 25, 1)
        self.image.set_from_file(imagepath)
        self.image.show()
        #self.eventbox = gtk.EventBox()
        #self.eventbox.add(self.image)
        #self.eventbox.set_above_child(False)
        #self.eventbox.add_events (gtk.gdk.BUTTON_RELEASE)
        #self.eventbox.connect("button_release_event", self.image_clicked, album)
        #self.eventbox.connect("enter-notify-event", self.show_vbControl)
        #self.eventbox.connect("leave-notify-event", self.hide_vbControl)
        #self.eventbox.show()
        #self.vbox.pack_start(self.eventbox, False, False, 0)#, 25, 1)
        self.__setcolor(self.eventFrame) # ???
        
        # Artist
        artist = album['artist_name']
        self.lArtist = gtk.LinkButton("", clear(artist)) #gtk.Label()
        self.lArtist.connect("clicked", self.lArtist_clicked)
        self.vbox.pack_start(self.lArtist, False, False, 0)#, 10, 110)
        self.lArtist.show()

        if self.par.debug_extreme:
            print _("Created AlbumInfo for %s[...]") % str(album['album_name'][:20])


    def lArtist_clicked(self, ev1="", ev2=""):
        artistdetails = self.par.db.artistinfos(self.album['artist_id'])
        self.par.clear_layout("artist", artistdetails)

    def lAlbum_clicked(self, ev1="", ev2=""):
        #print ev2
        #print self.album['album_id']
        albumdetails = self.par.jamendo.albuminfos(self.album['album_id'])
        self.par.clear_layout("album", albumdetails)

    def image_clicked(self, ev, ev2, ev3):
        x,y = self.image.get_pointer()
        if x > 0 and x < 100 and y > 0 and y < 100:
            #print self.album
            #self.par.layout['top'].hide()
            #print self.par.jamendo.albuminfos(self.album['album_id'])
            self.lAlbum_clicked()
        
    def __setcolor(self, widget):
        if self.par.nocolor:
            return None 
        style = widget.get_style()
        color = widget.get_colormap()
        bg = color.alloc_color(self.par.window.bgcolor)
        fg = color.alloc_color(0, 0, 0, 0)
        style.bg[gtk.STATE_NORMAL] = bg
        style.fg[gtk.STATE_NORMAL] = fg
        widget.set_style(style)
        
    def show_vbControl(self, ev1, ev2):
        self.vbControl.show()

    
    def hide_vbControl(self, ev1, ev2):
        x,y = self.vbControl.get_pointer()
        if x > 0 and x < 35 and y > 0 and y < 90: return None
        self.vbControl.hide()


    def on_bControlStar(self, ev1):
        print "star"

# this track-queries need a own function, i've got that
# three times (2x here, 1x in draw_albumdetail)
    def on_bControlPlay(self, ev1):
        tracks = self.par.db.albumtracks(self.album['album_id'])
        track_count = len(tracks)

        if track_count == 0:
            print _("Album not in database, yet.")
            #print album['public_date']
            dia = MyDialog(_('Album non existant.'),
                              self.par.window.get_toplevel(),
                              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
                                (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT), gtk.STOCK_DIALOG_WARNING, _('This album is not in the database.\nPerhaps Jamendo did not unloack that album, yet\n or you are using a old local database.'))
            dia.run()
            dia.destroy()
            return None

        self.par.appendtracks(tracks, play=True)
        
    def on_bControlAdd(self, ev1):
        tracks = self.par.db.albumtracks(self.album['album_id'])
        track_count = len(tracks)

        if track_count == 0:
            print _("Album not in database, yet.")
            #print album['public_date']
            dia = MyDialog(_('Album non existant.'),
                              self.par.window.get_toplevel(),
                              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
                                (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT), gtk.STOCK_DIALOG_WARNING, _('This album is not in the database.\nPerhaps Jamendo did not unloack that album, yet\n or you are using a old local database.'))
            dia.run()
            dia.destroy()
            return None

        self.par.appendtracks(tracks)

