#!/usr/bin/python
# -*- coding: utf-8 -*-

# GUI
import pygtk
pygtk.require('2.0')
import gtk
import gobject
gtk.gdk.threads_init()

# Glade
import gtk.glade

# Pango Markup
#import pango

# Time formatting
from time import strftime, gmtime, time, sleep

# Option Parser
from optparse import OptionParser

import os, sys
if os.name == "posix":
    sys.path.append("/usr/share/apps/pyjama") # linux
else:
    sys.path.append(os.path.join(os.getenv('PROGRAMFILES'), "pyjama")) # windows
from math import floor

# Laden von Dateien
import urllib
# Webbrowser
import webbrowser
import md5

# SimpleJSon
import simplejson

# Threading
import thread

#RegEx
import re

# Benutzerklassen
import clJamendo, clGstreamer010, clDB, clThreadedDownload #clPlayer
from constants import *     #ALL VARSIABLES IN CAPITALS ARE CONSTANTS
import functions
from clWidgets import *
import clEntry#, clProgressWindow
import clPlugin, clEvent
import notification

# Gettext - Übersetzung
functions.translation_gettext()
#def _(string):
#    return string

def sec2time(seconds):
    if seconds > (60*60):
        try:
            time_string = strftime("%H:%M:%S", gmtime(int(seconds)))
        except ValueError:
            return "00:00:00"
    else:
        try:
            time_string = strftime("%M:%S", gmtime(int(seconds)))
        except ValueError:
            return "00:00"
    return time_string
    
def urlencode(url):
    url = url.encode("utf-8")
    ret = urlencode({'x': url})
    return ret[2:]
    
def clear(string):
    if string == None: return string
    string = string.replace("\r", "")
    string = string.replace("\t", "")
    string = string.replace(",", "")
    return string


def tofast(window):
    dia = MyDialog(_('to fast'),
                              window.get_toplevel(),
                              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
                                (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT),        gtk.STOCK_DIALOG_WARNING, _('Some requests may only be send once a second\nin order not to slow down jamendo\'s database'))
    dia.run()
    dia.destroy()
    window.on_bHistoryBack_clicked(None)
    
class main():
    def __init__(self, parent, options):
        print "PYJAMA FOUND IN %s" % functions.install_dir()

        self.Events = clEvent.Events()
        self.Events.pluginloaded += self.ev_plugin_loaded
    
        # GTK WINDOW
        self.window = parent
        # USER CLASS TRAY ICON
        self.icon = notification.TrayIcon(self)
        # USER CLASS PLAYER
        self.player = clGstreamer010.Player(self)
        # USER CLASS JAMENDO FOR JAMENDO QUERIES
        self.jamendo = clJamendo.Jamendo(self)
        # USER CLASS LOCAL DATABASE
        self.db = clDB.DB()

        # VERBOSE AND / OR DEBUGGING
        self.verbose = options.verbose
        self.debug = options.debug
        self.debug_extreme = options.debug_extreme
        
        # REDUCES COLORS
        self.nocolor = options.theme != None or options.nocolor
        # SWITCHES EVERY 200 MS, really ugl, but got
        # no better ideo doing that
        self.allow_rearrange = True

        # Homedir
        self.home = functions.preparedirs()
        # Iters for Playlist Treeview
        self.tvMarkedItem = None
        # Albuminfo Widgets
        self.albuminfos={}
        
        # Tracks currently shown in draw_albumdetail
        # This was replaced through StockBotton- Tags!
        #self.tracks = {}
        
        # Is the Timer running?
#        self.timer = False
        
        # Currently shown Layout (top, album...)
        self.layout_mode = "top"

        # Standard Results per page
        self.results_per_page = 10
        # Standard Ordering of results
        self.ordering = "ratingweek"
        # Standard Tag
        self.tag = "all"
        # Page
        self.cur_page = 1
        
        # Is the Progressbar shown (for pulsing-timer)
        self.pulsing = False
        
        # HISTORY
        self.historyBack = []
        self.historyForward = []
        self.historyCurrent = {}

        # USER CLASS PLUGINS (loaded last, so that all
        #vars and methods are available to the plugins
        self.plugins = clPlugin.Plugins(self)

        # decided to let the timer run all the time
        self.start_timer()
        
        self.plugins.loaded['test2'].test()
        

    def ev_plugin_loaded(self, plugin):
        if self.verbose:
            print _("Plugin %s loaded") % plugin

    def set_allow_rearrange(self):
        self.allow_rearrange=True
        return False

    def check_next_possible(self, page=None, rpp=None):
        if page == None: page = self.cur_page
        if rpp == None: rpp = self.results_per_page
        if page >= floor(self.db.albums / rpp) - 2:
            self.window.sbNextPage.set_sensitive(False)
        else:
            self.window.sbNextPage.set_sensitive(True)

    def check_prev_possible(self, page=None):
        if page == None: page = self.cur_page
        if page == 1:
            self.window.sbPrevPage.set_sensitive(False)
        else:
            self.window.sbPrevPage.set_sensitive(True)

    def clear_layout(self, mode, data1=None, data2=None, data3=None, data4=None, fromhistory=False, who_called = None):
        self.layout_mode=mode
        #print data1; print data2; print data3; print data4; print who_called; print "########"
        #############################################################
        # HISTORY RELATED
        if self.historyCurrent != {} and fromhistory==False:
            self.historyBack.append(self.historyCurrent)
        if fromhistory == False:
            # got to be fixed, see below
            #self.historyForward = []
            pass
        self.historyCurrent = {'mode':mode, 'data1':data1, 'data2':data2, 'data3':data3, 'data4':data4}
        self.window.bHistoryForward.set_sensitive(len(self.historyForward)>0)
        self.window.bHistoryBack.set_sensitive(len(self.historyBack)>0)
        #############################################################
        self.window.scrolledwindow.remove(self.window.scrolledwindow.child) 
        self.window.scrolledwindow.add(self.window.layout[mode]) 
        self.window.layout[mode].show()
        # Setting the Scrollbar to  0
        self.window.scrolledwindow.set_vadjustment(gtk.Adjustment(value=0, lower=0, upper=0, step_incr=0, page_incr=0, page_size=0))
        self.window.hbTop.hide()
        if mode == "album":
            self.window.hbTopAlbum.show()
        else:
            self.window.hbTopAlbum.hide()
        if mode == "search":
            if data4 == None:
                markup = self.window.markuplbCaption.replace("TEXT", _("Search for artists, albums and tracks"))
            else:
                markup = self.window.markuplbCaption.replace("TEXT", _("You searched for '%s'") % data4)
                #markup = self.window.markuplbCaption.replace("TEXT", "Suchen sie nach Alben, Künstlern und Tracks")
            self.window.lbCaption.set_markup(markup)
            self.search_window(data1, data2, data3, data4)
        elif mode == "album":
            markup = self.window.markuplbCaption.replace("TEXT", _("Show album infos for '%s'") % data1['name'])
            self.window.lbCaption.set_markup(markup)
            self.draw_albumdetail(data1)
        elif mode == "top":
            if not data4: data4 = "all"
            self.set_album_browser(reload = False)
            self.check_next_possible(data3, data1)
            self.check_prev_possible(data3)
            # Got to be fixed: Setting CBs in History- Mode
            # causes "changed" event, which destroys the
            # current history- session
            # Switched off HistoryForwart- Deletion,
            # as this seems to be the smaller issue
            self.window.cbOrder.set_item(data2)            
            self.window.cbTags.set_item(data4)            
            if data4 == "all":
                markup = self.window.markuplbCaption.replace("TEXT", _("Show top %i albums in '%s'") % (int(data1), data2))
                self.window.lCurPage.set_text(_("Page %i of %i") % (data3, (self.db.albums/data1)))
            else:
                markup = self.window.markuplbCaption.replace("TEXT", _("Show %i albums tagged '%s' ordered by '%s'") % (int(data1), data4, data2))
                self.window.lCurPage.set_text(_("Page %i") % data3)
            self.window.cbResultsPerPage.set_item(data1)

            self.cur_page = data3
            self.window.lbCaption.set_markup(markup)
            self.window.hbTop.show()
            self.draw_topoftheweek(num=data1, mode=data2, page=data3, tag=data4)
        elif mode == "artist":
            markup = self.window.markuplbCaption.replace("TEXT", _("Showing infos and albums concerning '%s'") % data1[0]['artist_name'])
            self.window.lbCaption.set_markup(markup)
            self.draw_artistdetail(data1)
            
    def clear_layout_callback(self, ev1="", ev2=""):
        while gtk.events_pending:
            gtk.main_iteration()
        print ev1.destroy()

    def arrange_topoftheweek(self):
        if self.albuminfos == {}: return None
        if self.layout_mode != "top": return None
        width = self.window.scrolledwindow_width
        hspace = 20
        vspacer = 20
        
        imgwidth = 150
        imgheight = 160
        
        starty = 30
        
        y = 0
        x = 0
        for counter in self.albuminfos:
            if ((x+1) * imgwidth) + hspace*(x+1) >= width:
                y += 1
                x = 0
            self.window.layout['top'].move(self.albuminfos[counter], (imgwidth * x) + hspace*(x+1), (vspacer*(y+1) + (y * imgheight))+starty)
            x += 1
        height = (y+1) * (imgheight + vspacer) +starty
        self.window.layout['top'].set_size(width-20,height+vspacer)

    # Possible Modi:
    #
    # rating, ratingweek, ratingmonth
    # date
    # downloaded, listened, starred, playlisted
    #

    def draw_topoftheweek(self, num=None, mode="ratingweek", page=1, tag="all"):
        if num==None:num=self.results_per_page
        for albuminfo in self.albuminfos:
            self.albuminfos[albuminfo].destroy()
        
        self.albuminfos = {}
        

        top = self.jamendo.top(num, mode, page, tag)
        if top == None:
            tofast(self.window)
            return None
        ## Again:
        ## 2 loops in order to
        ## first burst download
        ## and then create AlbumInfo
        counter = 0
        threads = {}
        for album in top:
            if self.debug:
                print "(%i/%i)" % (counter + 1, len(top))
            # if more than 10 threads...
            if clThreadedDownload.threadLimiter(threads):
                print _("Waiting for threads (%i seconds)") % THREAD_WAIT
                sleep(THREAD_WAIT)
            threads[counter] = clThreadedDownload.Download(self, album['album_image'], counter)
            threads[counter].start()
            counter += 1
        counter = 0
        for album in top:
            self.albuminfos[counter] = AlbumInfo(self, album)
            self.albuminfos[counter].show()
            self.window.layout['top'].put(self.albuminfos[counter], counter, counter)
            counter += 1

        self.arrange_topoftheweek()
        
    def appendtracks(self, tracks, play = False):
        cur = len(self.player.playlist)
        for track in tracks:
            tracks[track]['uid'] = "%f%s" % (time(), tracks[track]['id'])
            self.add2playlist(tracks[track])
            status = self.player.status
        if play:
            self.window.on_bStop_clicked(None)
            self.setplaylist(cur)
            self.window.on_bPlay_clicked(None)        
        
    def add2playlist(self, track):
        self.player.add2playlist(track)
        
        artist_name = track['artist_name']
        track_name = track['name']
        markup = self.window.markupNormalEntry.replace("__ARTIST__", artist_name).replace("__TITLE__", track_name).replace("__NUM__", str(track['numalbum']))
        tmpIter = self.window.liststore.append([markup])

    def arrange_artistdetail(self):
        if self.albuminfos == {}: return None
        if self.layout_mode != "artist": return None
        width = self.window.scrolledwindow_width
        hspace = 20
        vspacer = 20
        
        imgwidth = 150
        imgheight = 160
        starty = 200
        
        y = 0
        x = 0
        self.window.layout['artist'].hide()
        for counter in self.albuminfos:
            if ((x+1) * imgwidth) + hspace*(x+1) >= width:
                y += 1
                x = 0
            self.window.layout['artist'].move(self.albuminfos[counter], (imgwidth * x) + hspace*(x+1), (vspacer*(y+1) + (y * imgheight))+starty)
            x += 1
        height = (y+1) * (imgheight + vspacer) +starty

        self.window.layout['artist'].set_size(width-20,height+vspacer)
        self.window.layout['artist'].show()

    def draw_artistdetail(self, artistinfos):
#        for label in self.labels:
#            self.labels[label].destroy()
        for albuminfo in self.albuminfos:
            self.albuminfos[albuminfo].destroy()
            
        self.albuminfos = {}

        img = artistinfos[0]['artist_image']
        name = artistinfos[0]['artist_name']
        artistID = artistinfos[0]['artist_id']
        #dispname = artistinfos[0]['artist_dispname']
        #genre = artistinfos[0]['artist_genre']
        country = artistinfos[0]['artist_country']
        #link = artistinfos[0]['artist_link']
        url = artistinfos[0]['artist_url']
        albums = artistinfos[0]['artist_albumcount']

        md5hash = md5.new(img).hexdigest()
        fh = os.path.join(self.home, "images", md5hash)
        if not os.path.exists(fh) and img != "":
            try:
                urllib.urlretrieve(img, fh)
            except IOError:
                print _("Could not load image")
                return None


        self.window.image_artist.clear()
        if img == "" or img == None:
            pixbuf = self.window.image_artist.render_icon(gtk.STOCK_MISSING_IMAGE, gtk.ICON_SIZE_DIALOG, detail=None)
            self.window.image_artist.set_from_pixbuf(pixbuf)
        else:
            self.window.image_artist.set_from_file(fh)
        

        content = [functions.decode_htmlentities(name), country, albums,  url]
        x = 0
        infos = self.window.ArtistInfos
        captions = self.window.ArtistCaptions
        for x in xrange(0, len(infos)):
            #self.window.layout['artist'].move(self.labels[infos[x]], xspace, y)
            if self.nocolor and infos[x] != "url":
                self.window.ArtistLabels[infos[x]].set_markup("<span><b>%s: %s</b></span>" % (captions[x], content[x]))
            elif infos[x] == "url":
                    self.window.ArtistLabels[infos[x]].set_label(url)
            else:
                self.window.ArtistLabels[infos[x]].set_markup("<span foreground=\"white\"><b>%s: %s</b></span>" % (captions[x], content[x]))
            #self.labels[infos[x]].set_line_wrap(True)
            #y+=yspace
            
        #### ARTIST'S ALBUMS ####
        threads = {}
        albums = []
        counter = 0
        for album in artistinfos:
            albums.append(str(artistinfos[counter]['album_id']))
            ## todo ##
            ## Replace Image-URL with constants!!!! ##
            artistinfos[counter]['album_image'] =  "http://imgjam.com/albums/%s/covers/1.100.jpg" % artistinfos[counter]['album_id']
            threads[counter] = clThreadedDownload.Download(self, artistinfos[counter]['album_image'], counter)
            threads[counter].start()
            counter += 1
        ## i added another loop
        ## so that threaded download
        ## won't collide with
        ## creating the albuminfos
        counter = 0
        for album in artistinfos:
            self.albuminfos[counter] = AlbumInfo(self, artistinfos[counter])
            self.albuminfos[counter].show()
            self.window.layout['artist'].put(self.albuminfos[counter], 1, 1)
            counter += 1

        ### Add Artist's Tracks to List ###
        self.window.tvList.clear()
        tracks = self.db.artisttracks(artistID)
        for track in tracks:
            results = [name, tracks[track]['album_name'], tracks[track]['numalbum'], tracks[track]['name'], tracks[track]['license'], artistID, tracks[track]['album_id'], tracks[track]['id']]
            self.window.tvList.add_item(results)

#        ### this is more than slow since
#        ### every artists' album is requested
#        ### on its own, need multiple cross- joins!!!
#        for album in albums:
#            tracks = self.db.albumtracks(album)
#            for track in tracks:
#                results = [tracks[track]['artist_name'], tracks[track]['album_name'], tracks[track]['numalbum'], tracks[track]['name'], tracks[track]['license'], tracks[track]['artist_id'], tracks[track]['album_id'], tracks[track]['id']]
#                self.window.tvList.add_item(results)

        self.arrange_artistdetail()


    def draw_albumdetail(self, albuminfos):
#        self.window.lbMoreAlbumsFromThisArtist.destroy()
#        self.window.lbMoreAlbumsFromThisArtist2.destroy()

        tracks = self.db.albumtracks(albuminfos['id'])
        track_count = len(tracks)

        if track_count == 0:
            print _("Album not in database, yet.")
            print albuminfos['public_date']
            dia = MyDialog(_('Album non existant.'),
                              self.window.get_toplevel(),
                              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
                                (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT), gtk.STOCK_DIALOG_WARNING, _('This album is not in the database.\nPerhaps Jamendo did not unloack that album, yet\n or you are using a old local database.'))
            dia.run()
            dia.destroy()
            self.window.on_bHistoryBack_clicked(None)
            return None


        #tags = albuminfos['id3genre']

        genre = albuminfos['id3genre']
        #desc = albuminfos['desc_str']
        #referrer_count = albuminfos['referrer_count']
            #playlisted_count = albuminfos['playlisted_count']
            #favourited_count = albuminfos['favourited_count']
        #lowfi_count = albuminfos['lowfi_count']
        releasedate = albuminfos['public_date']
        lengths = albuminfos['lengths']
            #license_id = albuminfos['license_id']
            #review_num = albuminfos['review_num']
        review_note = albuminfos['review_note']
            #review_num_week = albuminfos['review_num_week']
            #review_note_week = albuminfos['review_note_week']
        name = albuminfos['name']
        artist_id = albuminfos['artist_id']
        artist_name = tracks[0]['artist_name']
        album_id = albuminfos['id']
            #img = albuminfos['images'][0]['url']
        img = albuminfos['root_images'] + "1.200.jpg"
        url = ALBUM_URL.replace("URL", "%s" % album_id)

        self.window.tvList.clear()
        for track in tracks:
            results = [artist_name, name, tracks[track]['numalbum'],tracks[track]['name'], tracks[track]['license'], artist_id, album_id, tracks[track]['id']]
            self.window.tvList.add_item(results)


        self.window.lbAppendAlbum.tag = tracks #self.tracks = tracks

        #archives = albuminfos['archives'] #mp32 / ogg3 #filesize #filename #link_bittorrent #link_ed2k
        #upload_date = albuminfos['upload_date']
        md5hash = md5.new(img).hexdigest()
        fh = os.path.join(self.home, "images", md5hash)
        if not os.path.exists(fh):
            try:
                urllib.urlretrieve(img, fh)
            except IOError:
                print _("Could not load image")
                return None

        #self.image = gtk.Image()
        #self.vbox.pack_start(self.image, True, True, 0)#, 25, 1)
        #self.image.set_from_file(fh)


        self.window.image_album.clear()
        if img == "" or img == None:
            pixbuf = self.window.image_album.render_icon(gtk.STOCK_MISSING_IMAGE, gtk.ICON_SIZE_DIALOG, detail=None)
            self.window.image_album.set_from_pixbuf(pixbuf)
        else:
            self.window.image_album.set_from_file(fh)


        content = [ name, functions.decode_htmlentities(artist_name), track_count, sec2time(lengths), functions.id2genre(genre), releasedate, review_note, url ]
        x = 0
        infos = self.window.AlbumInfos
        namen = self.window.AlbumCaptions
        for x in xrange(0, len(infos)):
            if infos[x] == "review_note":
                if self.nocolor:
                    self.window.AlbumLabels[infos[x]].set_markup("<span><b>%s: </b></span>" % (namen[x]))
                else:
                    self.window.AlbumLabels[infos[x]].set_markup("<span foreground=\"white\"><b>%s: </b></span>" % (namen[x]))
                self.window.rtRating.set_rating(content[x])
            elif infos[x] == "url":
                    self.window.AlbumLabels[infos[x]].set_label(url)
            else:
                if self.nocolor:
                    self.window.AlbumLabels[infos[x]].set_markup("<span><b>%s: %s</b></span>" % (namen[x], content[x]))
                else:
                    self.window.AlbumLabels[infos[x]].set_markup("<span foreground=\"white\"><b>%s: %s</b></span>" % (namen[x], content[x]))


        # NEW ATTRIBUTE 'FLAG' IN STOCKBUTTON
        # NEED TO USE THIS FOR OTHER BUTTONS
        # HERE, TOO!
        self.window.sbGotoWeb.tag = url
        
        self.window.lbMoreAlbumsFromThisArtist2.tag = artist_id
        self.window.lbMoreAlbumsFromThisArtist2.set_tooltip_text(_("Show informations and albums from '%s'") % artist_name)
        self.window.sbDownloadAlbum.tag = album_id

        ## 
        ## this additional buttons on album-view
        ## are not necessary any more
        ##
#        self.window.lbMoreAlbumsFromThisArtist = ImageButton("%s/images/kdmconfig.png", 40, 40, _("Show informations and albums from '%s'") % (INSTALL_DIR, artist_name))
#        self.window.layout['album'].put(self.window.lbMoreAlbumsFromThisArtist, 10, 280)
#        self.window.lbMoreAlbumsFromThisArtist.connect("clicked", self.window.on_lbMoreAlbumsFromThisArtist_clicked, artist_id)
#        self.window.lbMoreAlbumsFromThisArtist.show()

        self.window.layout['album'].set_size(self.window.scrolledwindow_width-20,230)#350)#y+200

    # This Function was installed to pass search results
    # through "clear_layout" function, which supplies
    # history functionality!
    def prepare_search(self, ev):
        if len(self.window.eSearch.get_text())<3:
            self.clear_layout("search", -1)
            return None
        ret1 =  self.db.search_artist(self.window.eSearch.get_text())
        ret2 =  self.db.search_album(self.window.eSearch.get_text())
        ret3 =  self.db.search_track(self.window.eSearch.get_text())
        self.clear_layout("search", ret1, ret2, ret3, self.window.eSearch.get_text(), who_called = "prepare_search")

    def search_window(self, search=None, search2=None, search3=None, keyword=None):
        if search == None and search2 == None and search3 == None:
            self.window.SearchLabels['hits'].hide()
        else:
            self.window.SearchLabels['hits'].show()
        if search == -1:
            print _("Minimum length of 3 letters")
            return None

        if keyword:
            self.window.eSearch.set_text(keyword)
        self.window.set_focus(self.window.eSearch)

        hits_artists, hits_albums, hits_tracks = 0,0,0

        
        ### Results into Treeview
        # in order to fast that up, i should
        # disconnect listview from treeview
        # temporary
        self.window.tvList.clear()
        if search != None and len(search) > 0:
            for hit in search:
                results = [search[hit]['artist_name'], "", "", "", "", search[hit]['artist_id'], -1, -1]
                self.window.tvList.add_item(results)
            hits_artists = len(search)
                
        if search2 != None and len(search2) > 0:
            for hit in search2:
                results = [search2[hit]['artist_name'], search2[hit]['album_name'], "", "", "", search2[hit]['artist_id'], search2[hit]['album_id'], -1]
                self.window.tvList.add_item(results)
            hits_albums = len(search2)
            
        if search3 != None and len(search3) > 0:
            for hit in search3:
                results = [search3[hit]['artist_name'], search3[hit]['album_name'], search3[hit]['track_numalbum'], search3[hit]['track_name'], search3[hit]['track_license'], search3[hit]['artist_id'], search3[hit]['album_id'], search3[hit]['track_id']]
                self.window.tvList.add_item(results)
            hits_tracks = len(search3)

        if search or search2 or search3:
            hit_message = _("<u>%i hits</u>\n\n%i artists\n%i albums\n%i tracks") % (hits_artists + hits_albums + hits_tracks, hits_artists, hits_albums, hits_tracks)

            if self.nocolor:
                self.window.SearchLabels['hits'].set_markup("<span><b>%s</b></span>" % hit_message)
            else:
                self.window.SearchLabels['hits'].set_markup("<span foreground=\"white\"><b>%s</b></span>" % hit_message)

    def showInfo(self, path=None):
        if path == None:
            if self.tvMarkedItem != None and self.tvMarkedItem < len(self.player.playlist):
                path = self.tvMarkedItem
            else:
                return None
#        if path == None:
#            ret = self.window.tvPlaylistSelection.get_selected()
#            if ret != None:
#                model, retIter = ret
#                if retIter != None:
#                    path = model.get_path(retIter)[0]
#                else:
#                    return None
#            else:
#                return None
            
        track = self.player.playlist[path]
        #Covers = simplejson.loads(track['album_Covers'])

        img = self.get_album_image(track['album_id'])
        if not img: return None
        self.window.imgCover.set_from_file(img)
        self.window.lbCoverArtist.set_text(track['artist_name'])
        self.window.lbCoverAlbum.set_text(track['album_name'])

    def setplaylist(self, activate_item):

        self.window.pbSong.set_fraction(0)
        self.window.pbSong.set_text("")

        model = self.window.tvPlaylist.get_model()
        retIter = model.get_iter(activate_item)
        self.showInfo(activate_item)

        # Unmark last played Item
        if self.tvMarkedItem != None and self.player.last_played != None and self.tvMarkedItem < len(self.player.playlist):
            track = self.player.last_played
            artist_name = track['name']
            track_name = track['name']
            track_numalbum = str(track['numalbum'])
            markup = self.window.markupNormalEntry.replace("__ARTIST__", artist_name).replace("__TITLE__", track_name).replace("__NUM__", track_numalbum)
            self.window.liststore.set(model.get_iter(self.tvMarkedItem), 0, markup)

        # Mark cur. played item
        
        self.window.tvSelection.select_iter(retIter)
        track = self.player.playlist[activate_item] #self.player.cur_playing
        artist_name = track['artist_name']
        track_name = track['name']
        track_numalbum = str(track['numalbum'])
        markup = self.window.markupCurPlaying.replace("__ARTIST__", artist_name).replace("__TITLE__", track_name).replace("__NUM__", track_numalbum)
        self.window.liststore.set(retIter, 0, markup)
        # remember, which item is marked
        self.tvMarkedItem = activate_item

    def stop_timer(self):
        pass
        
    def start_timer(self):
        gobject.timeout_add(200, self.timer_event)
#        self.timer = True

    def start_pulsing(self, text = ""):
        gobject.timeout_add(50, self.pulse)
        self.window.pbWait.set_fraction(0)        
        self.window.pbWait.set_text(text)
        self.window.pbWait.show()
        
    
    def pulse(self):
        self.window.pbWait.pulse()
        if self.pulsing:
            return True
        else:
            return False
    
    def stop_pulsing(self):
        self.pulsing = False
        self.window.pbWait.hide()
    
    def timer_event(self):
        #self.window.pbWait.pulse()
        self.player.check_status()
        status = self.player.status
        status = _(status)
        fehler = ["Error", "Stop", "End", None]
        self.setStatus( status )
        if status == "paused":
            self.window.bPlay.setimage(gtk.STOCK_MEDIA_PLAY)
            self.window.bPlay.tag = "play"
            if self.window.pbSong.counter > 2:
                if self.window.pbSong.get_text() == _("paused"):
                    if self.window.pbSong.ShowRemainingTime:
                        txt =  "-%s" % sec2time(self.player.togo*-1)
                    else:
                        txt = "%s/%s" % (sec2time(self.player.cursec), sec2time(self.player.duration))
                else:
                    txt = _("paused")
                self.window.pbSong.set_text(txt)
                self.window.pbSong.counter = 0
            self.window.pbSong.counter +=1
            return True
        elif not status in fehler and self.player.percentage != None:
            if self.window.bPlay.tag != "pause":
                self.window.bPlay.setimage(gtk.STOCK_MEDIA_PAUSE)
                self.window.bPlay.tag = "pause"
            #print self.player.text
            if self.player.duration > 0 and self.player.duration < 59*60:
                self.window.pbSong.set_fraction(self.player.percentage)            
                if self.window.pbSong.ShowRemainingTime:
                    txt =  "-%s" % sec2time(self.player.togo*-1)
                else:
                    txt = "%s/%s" % (sec2time(self.player.cursec), sec2time(self.player.duration))
            else:
                self.window.pbSong.pulse()
                txt = "%s" % sec2time(self.player.cursec)
            self.window.pbSong.set_text(txt)
            return True
        elif status == "Stop" or status == "End": # and not self.pulsing:
            #self.window.bPlay.setimage(gtk.STOCK_MEDIA_PLAY)
            #self.window.bPlay.tag = "play"
            if self.icon.menu.play_button_status != "play":
                self.icon.menu.switch_play_button("play")
            self.window.pbSong.set_fraction(0)
            self.window.pbSong.set_text("")
#            self.timer = False
            return True
        else:
            return True   

    def setStatus(self, text):
        self.window.sbStatus.set_text("Player", text)

    def set_album_browser(self, reload = False):
        return None
        if self.ordering == "tag":
            self.window.cbOrder.hide()
            self.window.cbTags.show()
        else:
            self.window.cbOrder.show()
            self.window.cbTags.hide()
        if reload:
            self.clear_layout("top", self.results_per_page, self.ordering, self.cur_page, self.tag, who_called = "setalbumbrowser")    
            
    def notification(self, caption, text, icon="pyjama", size = 100):
        self.icon.show_notification(caption, text, icon, size)

    def switch_window_state(self, ev1):
        if self.window.window.get_state() & gtk.gdk.WINDOW_STATE_ICONIFIED:
            self.window.deiconify()
        else:
            self.window.iconify()

    def get_album_image(self, album_id, size = 100):
        img = "http://imgjam.com/albums/%s/covers/1.%i.jpg"  % (album_id, size)
        md5hash = md5.new(img).hexdigest()
        fh = os.path.join(self.home, "images", md5hash)
        if not os.path.exists(fh):
            try:
                urllib.urlretrieve(img, fh)
            except IOError:
                print _("Could not load image")
                return None
        return fh

class winGTK(gtk.Window):
    def __init__(self, parent=None):
        self.main = main(self, options)

        self.layout = {}

        ### Fullscreen indicator
        self.bolFullScreen = False

        ### Standard- Hintergrundfarbe:
        self.bgcolor = "#75A3D1"#"#4785C2"

        ### Standardfarben- Playlist
        self.CellBGColor = "STANDARD"
        self.CellSize = 8
        self.markupCurPlaying = '<span foreground="blue"><i><b>__ARTIST__</b></i>\n   __NUM__) __TITLE__</span>'
        self.markupNormalEntry ='<span>__ARTIST__\n   __NUM__) __TITLE__</span>'# '__ARTIST__\n\t__TITLE__' 
        self.markuplbCaption = "<span><b>TEXT</b></span>"
        
        gtk.Window.__init__(self)
#        try:
#            self.set_screen(parent.get_screen())
#        except AttributeError:
#            self.connect('delete', self.quit)

        self.connect('delete_event', self.quit)
        self.set_title("Pyjama - Jamendo Audiocenter")#(self.__class__.__name__)
        self.set_default_size(700, 500)
        self.set_icon_from_file(os.path.join(functions.install_dir(), "images", "pyjama.png"))
        self.set_skip_taskbar_hint(not SHOW_WINDOW_IN_TASKBAR)

        self.set_border_width(0)
        self.connect('window-state-event', self.window_state_event)
        
        self.vbox = gtk.VBox(False, 0)
        self.add(self.vbox)
        self.vbox.set_border_width(5)
        
        # Labels shown in Artist- View
        self.ArtistLabels={}

        # Labels shown in Album- View
        self.AlbumLabels={}

        # Labels for Search- Window
        self.SearchLabels={}

        #
        # Buttonbox -------------
        #
        ##### PLACE FOR MENU
        ###################
        
        # CREATE SIDEBAR
        self.hpaned = gtk.HPaned()
        self.vbox.pack_start(self.hpaned, True, True, 0)
        
        # CREATE MAIN VIEW
        self.vbMain = gtk.VBox()
        self.vpaned = gtk.VPaned()
        self.hpaned.pack1(self.vbMain, True, False)
        self.vbMedia = gtk.VBox()
        self.vbMain.pack_end(self.vbMedia, True, True)
        self.vbMedia.pack_end(self.vpaned, True, True)

        #################################################################
        # TOP NAVBAR
        # NAV BUTTONBOX
        self.buttonbox = gtk.HBox()
        #self.buttonbox.set_layout(gtk.BUTTONBOX_SPREAD)
        self.vbMain.pack_start(self.buttonbox, False, True)

        # BACK BUTTON
        self.bHistoryBack = StockButton(gtk.STOCK_GO_BACK, gtk.ICON_SIZE_DIALOG)
        self.buttonbox.pack_start(self.bHistoryBack, False, True, 2)
        self.bHistoryBack.set_tooltip_text(_("Show previous page in history"))
        self.bHistoryBack.connect("clicked", self.on_bHistoryBack_clicked)
        self.bHistoryBack.set_sensitive(False)

        # HOME
        self.bHome = StockButton(gtk.STOCK_HOME, gtk.ICON_SIZE_DIALOG)#BUTTON
        self.buttonbox.pack_start(self.bHome, False, False, 2)
        self.bHome.set_tooltip_text(_("Show start-page"))
        self.bHome.connect("clicked", self.on_bHome_clicked)

        # FWD BUTTON
        self.bHistoryForward = StockButton(gtk.STOCK_GO_FORWARD, gtk.ICON_SIZE_DIALOG)
        self.buttonbox.pack_start(self.bHistoryForward, False, False, 2)
        self.bHistoryForward.set_tooltip_text(_("Show next page in history"))
        self.bHistoryForward.connect("clicked", self.on_bHistoryForward_clicked)
        self.bHistoryForward.set_sensitive(False)
        
        # ABOUT BUTTON
        self.bAbout = StockButton(gtk.STOCK_ABOUT, gtk.ICON_SIZE_DIALOG)
        self.buttonbox.pack_end(self.bAbout, False, False, 2)
        self.bAbout.set_tooltip_text(_("Show infos about pyjama"))
        self.bAbout.connect("clicked", self.on_bAbout_clicked)
        
        # FULLSCREEN BUTTON
        self.bFullScreen = StockButton(gtk.STOCK_FULLSCREEN, gtk.ICON_SIZE_DIALOG)
        self.buttonbox.pack_end(self.bFullScreen, False, False, 2)
        self.bFullScreen.set_tooltip_text(_("Switch fullscreen/window-mode"))
        self.bFullScreen.connect("clicked", self.on_bFullScreen_clicked)
        
        # SEARCH
        self.bSearch = StockButton(gtk.STOCK_FIND, gtk.ICON_SIZE_DIALOG )
        self.buttonbox.pack_end(self.bSearch, False, False, 2)
        self.bSearch.set_tooltip_text(_("Search"))
        self.bSearch.connect("clicked", self.on_bSearch_clicked)
        
        #################################################################

        #################################################################
        # CREATE MEDIA VIEW
#        self.vpaned.pack1(self.vbTop, False, True)
        self.scrolledwindow = gtk.ScrolledWindow()
        self.scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        #self.scrolledwindow.set_size_request(550, 300) #zwangsgröße
        self.scrolledwindow.connect("size-allocate", self.scrolled_window_resize)        
        self.vpaned.pack1(self.scrolledwindow, True, True)

        self.layout['top'] = gtk.Layout()
        self.layout['top'].set_size(700,400)
        self.scrolledwindow.add(self.layout['top']) 
#        self.vbTop.pack_end(self.scrolledwindow, True, True, 0)
        
        self.layout['artist'] = gtk.Layout()
        self.layout['artist'].set_size(700,400)
        
        self.layout['album'] = gtk.Layout()
        self.layout['album'].set_size(700,400) #(700,400) (for the both bottoms I removed)
        
        self.layout['search'] = gtk.Layout()
        self.layout['search'].set_size(350,100)
        
        self.layout['tags'] = gtk.Layout()
        self.layout['tags'].set_size(350,100)
        
        ### TAG VIEW ###
        # ???!!!

        ### SEARCH VIEW ###
        self.SearchLabels['desc'] = gtk.Label("")
        self.SearchLabels['desc'].set_single_line_mode(False)
        self.layout['search'].put(self.SearchLabels['desc'], 10, 10)
        if self.main.nocolor:
            self.SearchLabels['desc'].set_markup(_("<span><b>Here you can search for artist, albums and tracks.\nEnter your search term in the text field\n\nAt most 100 results will be shown.</b></span>") )
        else:
            self.SearchLabels['desc'].set_markup(_("<span foreground=\"white\"><b>Here you can search for artist, albums and tracks.\nEnter your search term in the text field\n\nAt most 100 results will be shown.</b></span>"))
        self.SearchLabels['desc'].show()
            
        # SEARCH ENTRY
        self.hbSearch = gtk.HBox()
        self.layout['search'].put(self.hbSearch, 10, 80)
        self.eSearch = gtk.Entry()
        self.eSearch.connect("activate", self.main.prepare_search)
        self.hbSearch.pack_start(self.eSearch, True, True)
        
        # SEARCH Button
        self.bSearch2 = StockButton(gtk.STOCK_FIND, gtk.ICON_SIZE_SMALL_TOOLBAR )
        self.hbSearch.pack_start(self.bSearch2, True, True)
        self.bSearch2.connect("clicked", self.main.prepare_search)

        self.SearchLabels['hits'] = gtk.Label("")
        self.SearchLabels['hits'].set_single_line_mode(False)
        self.layout['search'].put(self.SearchLabels['hits'], 250,90)
        #self.hbSearch.pack_end(self.SearchLabels['hits'], True, True)
        self.hbSearch.show_all()
        
        ### ALBUM WIDGETS ###
        # Top Line- Action Buttons!
        self.hbTopAlbum = gtk.HBox()
        self.vbMain.pack_end(self.hbTopAlbum, False, True)
        # ADD ALBUM TO PLAYLIST
#        self.lbAppendAlbum = ImageButton("%s/images/juk.png", 40, 40, "" % INSTALL_DIR)
        self.lbAppendAlbum = StockButton(gtk.STOCK_ADD, gtk.ICON_SIZE_DND)
        self.hbTopAlbum.pack_start(self.lbAppendAlbum, False, True, 2)
        self.lbAppendAlbum.set_tooltip_text(_("Append this album on playlist"))
        self.lbAppendAlbum.show()
        self.lbAppendAlbum.connect("clicked", self.on_lbAppendAlbum_clicked)
        # GET MORE ALBUMS FROM THIS PLAYLIST
        self.lbMoreAlbumsFromThisArtist2 = StockButton(gtk.STOCK_INFO, gtk.ICON_SIZE_DND) # gtk.STOCK_ORIENTATION_PORTRAIT
        self.hbTopAlbum.pack_start(self.lbMoreAlbumsFromThisArtist2, False, True, 2)
        self.lbMoreAlbumsFromThisArtist2.connect("clicked", self.on_lbMoreAlbumsFromThisArtist_clicked)
        self.lbMoreAlbumsFromThisArtist2.show()
        # GO TO ALBUM'S PAGE ON JAMENDO
        self.sbGotoWeb = StockButton(gtk.STOCK_NETWORK, gtk.ICON_SIZE_LARGE_TOOLBAR)
        self.hbTopAlbum.pack_end(self.sbGotoWeb, False, True, 2)
        self.sbGotoWeb.set_tooltip_text(_("Goto to album's page on jamendo"))
        self.sbGotoWeb.set_size_request(50,50)
        self.sbGotoWeb.show()
        self.sbGotoWeb.connect("clicked", self.on_sbGotoWeb_clicked)        
        # DOWNLOAD ALBUM VIA TORRENT
        self.sbDownloadAlbum = StockButton(gtk.STOCK_GOTO_BOTTOM, gtk.ICON_SIZE_LARGE_TOOLBAR)
        self.hbTopAlbum.pack_end(self.sbDownloadAlbum, False, True, 2)
        self.sbDownloadAlbum.set_tooltip_text(_("Download Album as Torrent"))
        self.sbDownloadAlbum.set_size_request(50,50)
        self.sbDownloadAlbum.show()
        self.sbDownloadAlbum.connect("clicked", self.on_sbDownloadAlbum_clicked)            
        

        
        # Labels on Album Widget
        y = 10
        xspace = 250
        yspace = 20
        self.AlbumInfos = ['name', 'artist_name', 'trackcount', 'lengths', 'genre', 'releasedate', 'review_note', 'url']
        self.AlbumCaptions = [_("Album's title"), _("Artist"), _("#Tracks"), _("Length"), _("Genre"), _("Releasedate"), _('Rating'), _('link')]
        for info in xrange(0, len(self.AlbumInfos)):
            if self.AlbumInfos[info] == "url":
                self.AlbumLabels[self.AlbumInfos[info]] = gtk.LinkButton("", _("link")) #str(album['album_name'][:20])
                self.layout['album'].put(self.AlbumLabels[self.AlbumInfos[info]], xspace, y)
                self.AlbumLabels[self.AlbumInfos[info]].connect("clicked", self.on_zumAlbum_clicked)
                self.AlbumLabels[self.AlbumInfos[info]].show()
            else:
                self.AlbumLabels[self.AlbumInfos[info]] = gtk.Label("")
                self.AlbumLabels[self.AlbumInfos[info]].set_single_line_mode(True)
                self.layout['album'].put(self.AlbumLabels[self.AlbumInfos[info]], xspace, y)
                self.AlbumLabels[self.AlbumInfos[info]].show()
            if self.AlbumInfos[info] == "review_note":
                # USER WIDGET Rating
                self.rtRating = Rating()
                self.layout['album'].put(self.rtRating, 350, y)
                self.rtRating.show() # for some reason this is not done by self.show_all()
            y+=yspace
       
        ## 
        ## this additional buttons on album-view
        ## are not necessary any more
        ##
        #
        # add Album to Playlist
        #self.lbAppendAlbum = gtk.LinkButton("", "Dieses Album an die Playlist anhängen")
#        self.lbAppendAlbum = ImageButton("%s/juk.png", 40, 40, _("Append this album on playlist")  % INSTALL_DIR)
#        self.lbAppendAlbum.show()
#        self.layout['album'].put(self.lbAppendAlbum, 10, 220)
#        self.lbAppendAlbum.connect("clicked", self.on_lbAppendAlbum_clicked)

#        # get more albums from this artist
#        #self.lbMoreAlbumsFromThisArtist = gtk.LinkButton("", "Weitere Alben von diesem Künstler")
#        self.lbMoreAlbumsFromThisArtist = StockButton(gtk.STOCK_INFO, gtk.ICON_SIZE_DND)#gtk.STOCK_ORIENTATION_PORTRAIT)
#        self.layout['album'].put(self.lbMoreAlbumsFromThisArtist, 10, 280)

        self.image_album = gtk.Image()
        self.layout['album'].put(self.image_album, 30, 10)
        self.image_album.show()
        

        ### ARTIST WIDGETS ###
        # Labels for Artist- View
        #self.ArtistInfos = ['name', 'country', 'albums', 'Link']
        #self.ArtistCaptions = ["Name", "Land", "Anzahl der Alben", "Jamendo Seite"]

        y = 10          # current y position
        xspace = 250    # spacing on x- axes
        yspace = 20     # spacing on y- axes
        self.ArtistInfos = ['name', 'country', 'albums', 'url']
        self.ArtistCaptions = [_("Name"), _("Country"), _("#Albums"), _("link")]
        for info in xrange(0, len(self.ArtistInfos)):
            if self.ArtistInfos[info] == "url":
                self.ArtistLabels[self.ArtistInfos[info]] = gtk.LinkButton("", _("link")) #str(album['album_name'][:20])
                self.layout['artist'].put(self.ArtistLabels[self.ArtistInfos[info]], xspace, y)
                self.ArtistLabels[self.ArtistInfos[info]].show()
                self.ArtistLabels[self.ArtistInfos[info]].connect("clicked", self.on_zumArtist_clicked)
            else:
                self.ArtistLabels[self.ArtistInfos[info]] = gtk.Label("")
                self.ArtistLabels[self.ArtistInfos[info]].set_single_line_mode(True)
                self.layout['artist'].put(self.ArtistLabels[self.ArtistInfos[info]], xspace, y)
                self.ArtistLabels[self.ArtistInfos[info]].show()
            y+=yspace
            
        self.image_artist = gtk.Image()
        self.layout['artist'].put(self.image_artist, 30, 10)
        self.image_artist.show()
        
        self.__setcolor(self.layout['top'])
        self.__setcolor(self.layout['album'])
        self.__setcolor(self.layout['artist'])
        self.__setcolor(self.layout['search'])
        #################################################################
      
        #################################################################
        # Top- VIEW, Result p Page etc.
        #
        # this vbox devides next hbox from infolabel following
        self.vbTop = gtk.VBox()
        self.vbMedia.pack_end(self.vbTop, False, True)
        # this hbox contains resultsperpage and ordering
        self.hbTop = gtk.HBox()
        self.vbTop.pack_end(self.hbTop, False, True,0)
        # ComboBoxes for TOP- View
        self.cbOrder = OrderCombo()
        self.cbOrder.show()
        self.cbOrder.connect("changed", self.cbOrder_changed)
        self.hbTop.pack_start(self.cbOrder, False, True, 0)
        # Combo for Tags
        self.cbTags = TagsCombo()
#        self.cbTags.connect("key_press_event", self.cbTags_key_press_event)
#        self.cbTags.set_events(gtk.gdk.KEY_PRESS_MASK)
        self.cbTags.connect("changed", self.cbTags_changed)
        self.hbTop.pack_start(self.cbTags, False, True, 0)
        # RESULTS PER PAGE
        self.cbResultsPerPage = ResultsPerPageCombo()
        self.cbResultsPerPage.connect("changed", self.cbResultsPerPage_changed)
        self.hbTop.pack_start(self.cbResultsPerPage, False, True, 0)

        # Page- Buttons:
        self.sbNextPage = StockButton(gtk.STOCK_GO_FORWARD)
        self.sbNextPage.set_tooltip_text(_("Next page"))
        self.sbNextPage.connect("clicked", self.on_sbNextPage_clicked)
        self.hbTop.pack_end(self.sbNextPage, False, True, 0)

        self.lCurPage = gtk.Label()
        self.hbTop.pack_end(self.lCurPage, False, True, 0)

        self.sbPrevPage = StockButton(gtk.STOCK_GO_BACK)
        self.sbPrevPage.set_tooltip_text(_("Previous page"))
        self.sbPrevPage.connect("clicked", self.on_sbPrevPage_clicked)
        self.sbPrevPage.set_sensitive(False)
        self.hbTop.pack_end(self.sbPrevPage, False, True, 0)

        self.sbJumpToPage = StockButton(gtk.STOCK_JUMP_TO)
        self.sbJumpToPage.set_tooltip_text(_("Jump to page..."))
        self.sbJumpToPage.connect("clicked", self.on_sbJumpToPage_clicked)
        self.hbTop.pack_end(self.sbJumpToPage, False, True, 0)

        
        # Info- Label
        # contains title for currently shown Layout
        self.lbCaption = gtk.Label("")
        self.vbMain.pack_end(self.lbCaption, False, True ,0)
        #################################################################
        

        #################################################################
        # PLAYLIST
        # CREATE TREEVIEW 
        self.vpSideBar = gtk.VPaned()
        self.swTreeView = gtk.ScrolledWindow()
        self.swTreeView.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        # create a liststore with one string column to use as the model
        self.liststore = gtk.ListStore(gobject.TYPE_STRING)
        # create the TreeView using liststore
        self.tvPlaylist = gtk.TreeView(self.liststore)
        self.tvPlaylist.connect("row_activated", self.on_tvPlaylist_row_activated)
        self.tvPlaylist.connect("cursor-changed", self.on_tvPlaylist_cursor_changed)
        self.tvPlaylist.connect("motion-notify-event", self.on_tvPlaylist_motion_notify)
        self.tvPlaylist.connect("leave-notify-event", self.on_tvPlaylist_leave_notify)
        #self.tvPlaylist.set_hover_selection(True)
        # TreeSelection:
        self.tvPlaylistSelection = self.tvPlaylist.get_selection()
        self.tvPlaylistSelection.set_mode(gtk.SELECTION_SINGLE)
        # CELLRENDERER FOR TEXT
        self.cell = gtk.CellRendererText()
        # CREATE COLUMN 
        # create the TreeViewColumns to display the data
        self.tvColumn = gtk.TreeViewColumn('Playlist', self.cell, markup=0)#text=0)
        # ADD COLUMN TO TV
        self.tvPlaylist.append_column(self.tvColumn)
        # DRAG&DROP
#        self.tvPlaylist.connect("drag_data_get", self.drag_data_get_data)
#        self.tvPlaylist.connect("drag_data_received",self.drag_data_received_data)
        # Pack TV INTO SCROLLED WINDOW
        self.swTreeView.add(self.tvPlaylist)
        self.swTreeView.set_size_request(150, 100)

        # PROGRESSBAR
        self.pbSong = gtk.ProgressBar()
        self.pbSong.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
        self.pbSong.set_pulse_step(0.05)        
        self.ebProgressbar = gtk.EventBox()
        self.ebProgressbar.add(self.pbSong)
        self.ebProgressbar.set_above_child(False)
        self.ebProgressbar.add_events (gtk.gdk.BUTTON_RELEASE)
        self.ebProgressbar.connect("button_release_event", self.on_pbSong_clicked)
        self.pbSong.ShowRemainingTime = False
        self.pbSong.counter = 0
        
        # HSCALE AS VOLUME CONTROL
        hsAdjustment = gtk.Adjustment(value=DEFAULT_VOL, lower=0, upper=VOL_MAX, step_incr=1, page_incr=10, page_size=0)
        self.hsVolume = gtk.HScale(hsAdjustment)
        self.hsVolume.set_draw_value(False)      
        #self.hsVolume.set_digits(0)
        #self.hsVolume.set_value_pos(gtk.POS_BOTTOM)
        self.hsVolume.connect("change-value", self.on_sbVolume_Change)
        #################################################################        

        #################################################################
        #
        # TABLE FOR PLAYER- CONTROL
        #
        #self.bbControls = gtk.HButtonBox()
        #self.bbControls.set_spacing(gtk.BUTTONBOX_SPREAD)
        self.tbControls = gtk.Table(1, 4, True)
        
        # POSSIBLE SIZES FOR STOCKBUTTON
        # gtk.ICON_SIZE_INVALID gtk.ICON_SIZE_MENU gtk.ICON_SIZE_SMALL_TOOLBAR gtk.ICON_SIZE_LARGE_TOOLBAR   
        # gtk.ICON_SIZE_BUTTON gtk.ICON_SIZE_DND gtk.ICON_SIZE_DIALOG
        # DEFAULT IS gtk.ICON_SIZE_MENU
        # PREV- Button
        self.bPrev = StockButton(gtk.STOCK_MEDIA_PREVIOUS)
        #self.bbControls.add(self.bPrev False, True, 0)
        self.bPrev.connect("clicked", self.on_bPrev_clicked)
        self.bPrev.set_tooltip_text(_("Play previous"))
        self.tbControls.attach(self.bPrev, 0, 1, 0, 1)
        # Play- Button       
        self.bPlay = StockButton(gtk.STOCK_MEDIA_PLAY)
        #self.bbControls.pack_start(self.bPlay, False, True, 0)
        self.bPlay.connect("clicked", self.on_bPlay_clicked)
        self.bPlay.set_tooltip_text(_("Play/pause"))
        self.tbControls.attach(self.bPlay, 1, 2, 0, 1)
        # Stop- Button
        self.bStop = StockButton(gtk.STOCK_MEDIA_STOP)
        #self.bbControls.pack_start(self.bStop, False, True, 0)
        self.bStop.connect("clicked", self.on_bStop_clicked)
        self.bStop.set_tooltip_text(_("Stop"))
        self.tbControls.attach(self.bStop, 2, 3, 0, 1)
        # Next- Button
        self.bNext = StockButton(gtk.STOCK_MEDIA_NEXT)
        #self.bbControls.pack_start(self.bNext, False, True, 0)
        self.bNext.connect("clicked", self.on_bNext_clicked)
        self.bNext.set_tooltip_text(_("Play next"))
        self.tbControls.attach(self.bNext, 3, 4, 0, 1)
        #################################################################
        
        #################################################################
        #
        # TABLE FOR PLAYLIST- CONTROL
        #
        self.tbPlaylist = gtk.Table(1, 4, True)
        # DELETE- Button
        self.bDelete = StockButton(gtk.STOCK_REMOVE)#STOCK_DELETE
        self.bDelete.connect("clicked", self.on_bDelete_clicked)
        self.bDelete.set_tooltip_text(_("Remove selected song from playlist"))
        self.tbPlaylist.attach(self.bDelete, 0, 1, 0, 1)
        # CLEAR- Button
        self.bClear = StockButton(gtk.STOCK_CLEAR)#CLEAR
        self.bClear.connect("clicked", self.on_bClear_clicked)
        self.bClear.set_tooltip_text(_("Clear playlist"))
        self.tbPlaylist.attach(self.bClear, 1, 2, 0, 1)
        # SAVE- Button
        self.bSave = StockButton(gtk.STOCK_SAVE)
        self.bSave.connect("clicked", self.on_bSave_clicked)
        self.bSave.set_tooltip_text(_("Save playlist"))
        self.tbPlaylist.attach(self.bSave, 2, 3, 0, 1)
        # LOAD- Button
        self.bLoad = StockButton(gtk.STOCK_OPEN)
        self.bLoad.connect("clicked", self.on_bLoad_clicked)
        self.bLoad.set_tooltip_text(_("Load playlist"))
        self.tbPlaylist.attach(self.bLoad, 3, 4, 0, 1)
        #################################################################

        #################################################################
        #
        # ADD TO SIDEBAR
        #
        # ADD VPaned TO HPANED
        self.hpaned.pack2(self.vpSideBar, False, True) #swTreeView
        
        # COVER VIEW
        self.vbCover = gtk.VBox()
        self.vpSideBar.pack1(self.vbCover, False, True)
        self.lbCoverArtist = gtk.Label("")
        self.lbCoverAlbum = gtk.Label("")
        self.imgCover = gtk.Image()
        self.vbCover.pack_start(self.imgCover, False, True)
        self.vbCover.pack_start(self.lbCoverArtist, False, True)
        self.vbCover.pack_start(self.lbCoverAlbum, False, True)
        #self.tmpLABEL.set_size_request(1, 100)
        
        # CREATE VBOX
        self.vbSideBar = gtk.VBox(False, 0)
        # ADD VBOX TO VPANED
        self.vpSideBar.pack2(self.vbSideBar, True, True)
        # ADD BUTTONBOX CONTROLS TO VBOX
        self.vbSideBar.pack_start(self.tbControls, False, True)
        # ADD SCROLLBAR TO VBOX
        self.vbSideBar.pack_start(self.hsVolume, False, True)
        # ADD PROGRESSBAR's EVENTBOX TO VBOX
        self.vbSideBar.pack_start(self.ebProgressbar, False, True)
        # ADD TV TO VPANED
        self.vbSideBar.pack_start(self.swTreeView, True, True)
        # ADD BUTTONBOX CONTROLS PLAYLIST TO VBOX
        self.vbSideBar.pack_start(self.tbPlaylist, False, True)

        self.tvSelection = self.tvPlaylist.get_selection()
        #################################################################        

        #################################################################
        # USER WIDGET STATUSBAR
        self.sbStatus = StatusBar("Counter", "Info", "Player")
        self.sbStatus.set_text("Counter", _("Artists: %i, Albums: %i, Tracks: %i") % (self.main.db.artists, self.main.db.albums, self.main.db.tracks))
        self.sbStatus.show()
        self.vbox.pack_start(self.sbStatus, False, True, 0)
        
        self.pbWait = gtk.ProgressBar()
        self.vbox.pack_start(self.pbWait, False, True, 0)
        self.pbWait.set_pulse_step(0.02)        
        self.pbWait.show()
        #################################################################
        
#       model, iter = treeselection.get_selected()

#        REMOVE SELECTED
#        selection = self.tvPlaylist.get_selection()
#        model, iter = selection.get_selected()

#        if iter:
#            path = self.liststore.get_path(iter)[0]
#            self.liststore.remove(iter)
#            print path
#            del articles[ path ]

        #################################################################
        ### BACKGROUND COLORS
        if self.CellBGColor != "STANDARD":
            self.cell.set_property('cell-background', self.CellBGColor)
        self.cell.set_property('size-points', self.CellSize)
        #################################################################
        
        #################################################################
        # BOTTOM LIST SHOWING TRACKS
        # TreeView
        # CREATE TREEVIEW 
        self.swTVList = gtk.ScrolledWindow()
        self.swTVList.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.tvList = TreeViewList()
        self.tvList.connect("row_activated", self.on_tvList_row_activated)
        self.swTVList.add(self.tvList)
        self.vpaned.pack2(self.swTVList, True, True)

        #################################################################


        #self.connect("configure-event", self.test2)

        self.show_all()
        
        self.hbTopAlbum.hide()
        self.pbWait.hide()     

        # Show starting- window
        self.main.clear_layout("top", 10, "ratingweek", 1, "all", who_called = "window.__init__")
        #self.main.draw_topoftheweek()


    def window_state_event(self, widget, event):
        if event.new_window_state & gtk.gdk.WINDOW_STATE_ICONIFIED:
            self.window.visible = False
        
    def on_tvPlaylist_leave_notify(self, treeview, event):
        self.main.showInfo()

    def on_tvPlaylist_motion_notify(self, treeview, event):
        ret = treeview.get_path_at_pos(int(event.x), int(event.y))

        if ret != None:
            current_path, current_column = ret[:2]
            self.main.showInfo(current_path[0])
#            #print current_column.get_title()
#            renderer = current_column.get_cell_renderers()
#            if renderer != None:
#                renderer = renderer[0]
#                current_position = current_column.cell_get_position(renderer)
#                if current_position:
#                    current_position = current_position[0]
#                    print current_position
#            else:
#                return None
    def on_tvPlaylist_cursor_changed(self, treeview):
            self.main.showInfo()

    def on_pbSong_clicked(self, ev, ev2):
        self.pbSong.ShowRemainingTime = not self.pbSong.ShowRemainingTime
        self.main.timer_event()

    def on_tvPlaylist_row_activated(self, treeview, path, view_column):
        self.on_bStop_clicked(None)
        self.on_bPlay_clicked(None)

    def on_tvList_row_activated(self, treeview, path, view_column):
        # ==> view_column ==> geklickte Spalte!
        ret = self.tvList.get_item(path)
        tracknum = ret[self.tvList.COLUMN_TRACKNUM]
        trackid = ret[self.tvList.COLUMN_TRACKID]
        albumid = ret[self.tvList.COLUMN_ALBUMID]
        artistid = ret[self.tvList.COLUMN_ARTISTID]
        if trackid > -1:
            track = self.main.db.get_trackinfos(trackid, albumid, artistid)[0]
            track['uid'] = "%f%s" % (time(), trackid)
            self.main.add2playlist(track)
        elif albumid > -1:
            print albumid
            albumdetails = self.main.jamendo.albuminfos(albumid)
            if albumdetails == None:
                tofast(self.window)
                return None
            self.main.clear_layout("album", albumdetails, who_called = "on_tvList_row_activated")
        elif artistid > -1:
            artist = self.main.db.artistinfos(artistid)
            self.main.clear_layout("artist", artist, who_called = "on_tvList_row_activated")

    def on_bSearch_clicked(self, ev):
        self.main.clear_layout("search", who_called = "on_bSearch_clicked")


    def on_bAbout_clicked(self, ev):
        xml = gtk.glade.XML(os.path.join(functions.install_dir(), "about.glade"))
        as = xml.get_widget('About')
        as.run()
        as.destroy()
    def on_bFullScreen_clicked(self, ev):
        if not self.bolFullScreen:
            self.bFullScreen.setimage(gtk.STOCK_LEAVE_FULLSCREEN, gtk.ICON_SIZE_DIALOG)
            self.bolFullScreen = True
            self.fullscreen()
        else:
            self.bFullScreen.setimage(gtk.STOCK_FULLSCREEN, gtk.ICON_SIZE_DIALOG)
            self.bolFullScreen = False
            self.unfullscreen()

    def on_sbJumpToPage_clicked(self, ev):
        result = clEntry.input_box(title='Springe zu Seite',
            message='Bitte Seite eingeben',
            default_text="%i" % (self.main.cur_page+10))
        if result is None:
            return None
        elif not result.isdigit():
            dia = MyDialog('ungültige Eingabe',
                              self.get_toplevel(),
                              gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, 
                                (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT),        gtk.STOCK_DIALOG_WARNING, _('\'%s\' is not a valid page') % str(result))
            dia.run()
            dia.destroy()
            return None
        else:
            page = int(result)
        if self.main.layout_mode == "top":
            self.main.clear_layout("top", self.main.results_per_page, self.main.ordering, page, self.main.tag, who_called = "on_sbjumptopage_clicked")
        self.main.check_next_possible()
        self.main.check_prev_possible()
            
    def on_sbNextPage_clicked(self, ev):
        if self.main.layout_mode == "top":
            self.main.clear_layout("top", self.main.results_per_page, self.main.ordering, self.main.cur_page+1, self.main.tag, who_called = "on_sbnextpage_clicked")
        self.main.check_next_possible()

    def on_sbPrevPage_clicked(self, ev):
        if self.main.layout_mode == "top":
            self.main.clear_layout("top", self.main.results_per_page, self.main.ordering, self.main.cur_page-1, self.main.tag, who_called = "on_sbprevpage_clicked")
        self.main.check_prev_possible()

    def on_lbMoreAlbumsFromThisArtist_clicked(self, ev):
        # query db for artist informations and more albums
        self.main.start_pulsing(text = _("Requesting local database"))
        ret = self.main.db.artistinfos(self.lbMoreAlbumsFromThisArtist2.tag, time())        
        self.main.stop_pulsing()
        self.main.clear_layout("artist", ret, who_called = "on_lbMoreAlbumsFromThisArtist_clicked")


    def on_lbAppendAlbum_clicked(self, ev):
        tracks = self.lbAppendAlbum.tag
        for track in tracks: # for track in self.main.tracks:
            tracks[track]['uid'] = "%f%s" % (time(), tracks[track]['id'])
            self.main.add2playlist(tracks[track])
            status = self.main.player.status
            if status == "Error" or status == "End" or status == None:
                self.on_bPlay_clicked(None)
    
    def on_sbGotoWeb_clicked(self, ev):
        webbrowser.open_new_tab( self.sbGotoWeb.tag)
        
    def on_sbDownloadAlbum_clicked(self, ev):
        url = "http://api.jamendo.com/get2/bittorrent/file/redirect/?album_id=%s&type=archive&class=%s" % (self.sbDownloadAlbum.tag, FORMAT)
        webbrowser.open_new_tab(url)        

    def on_bHistoryForward_clicked(self, ev):
        if len(self.main.historyForward) >= HISTORY_SIZE:
            self.main.historyForward.pop(0)
        if len(self.main.historyForward) > 0:
            self.main.historyBack.append(self.main.historyCurrent)
            ret = self.main.historyForward.pop()
            mode = ret['mode']
            data1 = ret['data1']
            data2 = ret['data2']
            data3 = ret['data3']
            data4 = ret['data4']
            self.main.clear_layout(mode, data1, data2, data3, data4, fromhistory=True, who_called = "on_bHistoryForward_clicked")
        
    def on_bHistoryBack_clicked(self, ev):
        if len(self.main.historyBack) >= HISTORY_SIZE:
            self.main.historyBack.pop(0)
        if len(self.main.historyBack) > 0:
            self.main.historyForward.append(self.main.historyCurrent)
            ret = self.main.historyBack.pop()
            mode = ret['mode']
            data1 = ret['data1']
            data2 = ret['data2']
            data3 = ret['data3']
            data4 = ret['data4']
            self.main.clear_layout(mode, data1, data2, data3, data4, fromhistory=True, who_called = "on_bHistoryBack_clicked")

    def on_bDelete_clicked(self, ev):
        liststore, markedIter = self.tvPlaylistSelection.get_selected()
        if markedIter:
            model = self.tvPlaylist.get_model()
            self.main.player.remove(model.get_path(markedIter))

            liststore.remove(markedIter)

    def on_bClear_clicked(self, ev):
        self.main.player.clearplaylist()
        model = self.tvPlaylist.get_model()
        model.clear()

    def on_bNext_clicked(self, ev):
        self.on_bStop_clicked(None)
        self.main.player.next()
        self.main.icon.menu.switch_play_button("pause")
        
    def on_bPrev_clicked(self, ev):
        self.on_bStop_clicked(None)    
        self.main.player.prev()
        self.main.icon.menu.switch_play_button("pause")

    def on_bLoad_clicked(self, ev):
        #TO BE IMPROVED:
        #Right now pyjama queries every trackid
        #at the database on its own.

        buttons = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN,   gtk.RESPONSE_OK)
        dialog = gtk.FileChooserDialog(_("Load Playlist"), None, action=gtk.FILE_CHOOSER_ACTION_OPEN, buttons=buttons, backend=None)
        filter1 = gtk.FileFilter()
        filter1.set_name("M3U Playlist Format")
        filter1.add_pattern("*.m3u")
        dialog.add_filter(filter1)
#        filter2 = gtk.FileFilter()
#        filter2.set_name("XSPF Playlist Format")
#        filter2.add_pattern("*.xspf")
#        dialog.add_filter(filter2)

        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_current_folder(os.getenv("HOME"))
#        dialog.set_current_name("pyjama-playlist")

        response = dialog.run()
        dialog.hide()
        if response == gtk.RESPONSE_OK:
            filename = dialog.get_filename()
            if self.main.debug:
                print "Loading Playlist %s" % filename
            fh = file(filename, "r")
            if fh:
                lines = fh.readlines()
                fh.close()
            else:
                print _("Error reading %s") % filename
                return
            if dialog.get_filter() == filter1: #M3U
                tracks = []
                rg = re.compile('.*?\\d+.*?(\\d+)',re.IGNORECASE|re.DOTALL)
                for line in lines:
                    if "jamendo.com/get2/stream/track/redirect/?id=" in line:
                        m = rg.search(line.strip())
                        if m:
                            track_id=m.group(1)
                            tracks.append( track_id )
                            self.main.add2playlist( self.main.db.get_trackinfos2(track_id)[0] )
                    else:
                        print _("This is not a Jamendo track or not readable with pyjama: %s") % line.strip()

    def on_bSave_clicked(self, ev):
        m3u = ""
        xspf = '''<?xml version="1.0" encoding="UTF-8"?>
<playlist version="1" xmlns="http://xspf.org/ns/0/">
    <tracklist>
'''
        playlist = self.main.player.playlist
        for track in playlist:
            m3u += playlist[track]['stream']+"\n"
            xspf += "    <track>\n      <title>%s</title>\n       <creator>%s</creator>\n       <location>%s</location>\n    </track>\n" % (playlist[track]['name'], playlist[track]['artist_name'], playlist[track]['stream'])

        m3u = m3u[0:-1]
        xspf += '''\n    <tracklist>
</playlist>'''

        buttons = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_SAVE,   gtk.RESPONSE_OK)
        dialog = gtk.FileChooserDialog(_("Save Playlist"), None, action=gtk.FILE_CHOOSER_ACTION_SAVE, buttons=buttons, backend=None)
        filter1 = gtk.FileFilter()
        filter1.set_name("M3U Playlist Format")
        filter1.add_pattern("*.m3u")
        dialog.add_filter(filter1)
        filter2 = gtk.FileFilter()
        filter2.set_name("XSPF Playlist Format")
        filter2.add_pattern("*.xspf")
        dialog.add_filter(filter2)

        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_current_folder(os.getenv("HOME"))
        dialog.set_current_name("pyjama-playlist")

        response = dialog.run()
        dialog.hide()
        if response == gtk.RESPONSE_OK:
            filename = dialog.get_filename()
            if dialog.get_filter() == filter1: #IF M3U
                content = m3u
                if filename[-4:] != ".m3u":
                    filename += ".m3u"
            else: #XSPF
                content = xspf
                if filename[-5:] != ".xspf":
                    filename += ".xspf"
            if self.main.debug:
                print "Writing to %s" % filename
            fh = open(filename, "w")
            if fh:
                fh.write(content)
                fh.close()
            else:
                print _("Error writing %s") % filename

    def set_play(self):
        status = self.bPlay.tag
        if status == "play" or not status:
            status = "play"
        
        if status == "pause" and self.main.player.is_playing:
            self.main.player.pause()
            self.bPlay.setimage(gtk.STOCK_MEDIA_PLAY)
            self.main.icon.menu.switch_play_button("play")
            self.bPlay.tag = "play"
            return "paused"
        elif status == "play" and self.main.player.status == "paused":
            self.main.player.play()
            self.bPlay.setimage(gtk.STOCK_MEDIA_PAUSE)
            self.main.icon.menu.switch_play_button("pause")
            self.bPlay.tag = "pause"
            return "continued"
        elif status == "play":
            self.bPlay.setimage(gtk.STOCK_MEDIA_PAUSE)
            self.main.icon.menu.switch_play_button("pause")
            self.bPlay.tag = "pause"            
            return "play"
            

        
    def on_bPlay_clicked(self, ev):
        stat =  self.set_play()
        if stat == "paused":
            return
        elif stat == "continued":
            return
        model, tmpIter = self.tvSelection.get_selected()
        if tmpIter != None:
            path = self.liststore.get_path(tmpIter)[0]
            self.main.player.play(self.main.player.playlist[path], path)
            self.main.timer_event()
#            if not self.main.timer:
#                self.main.start_timer()
        else:
            model = self.tvPlaylist.get_model()
            # improve this
            try:
                tmpIter = model.get_iter(0)
            except ValueError:
                return None
            path = self.liststore.get_path(tmpIter)[0]
            self.main.player.play(self.main.player.playlist[path], path)
            self.main.timer_event()
#            if not self.main.timer:
#                self.main.start_timer()

                
    def on_bStop_clicked(self, ev):
        self.main.icon.menu.switch_play_button("play")
        self.bPlay.setimage(gtk.STOCK_MEDIA_PLAY)
        self.bPlay.tag = "play"
        listview, markedIter = self.tvPlaylistSelection.get_selected()
        
        # Unmark last played Item
        if markedIter != None and self.main.player.cur_playing != None:
            track = self.main.player.cur_playing
            artist_name = track['artist_name']
            track_name = track['name']
            track_numalbum = track['numalbum']
            markup = self.markupNormalEntry.replace("__ARTIST__", artist_name).replace("__TITLE__", track_name).replace("__NUM__", str(track_numalbum))
            self.liststore.set(markedIter, 0, markup)

        self.main.player.stop()

    def on_zumAlbum_clicked(self, ev):
        url = self.AlbumLabels['url'].get_label()
        webbrowser.open(url)
    def on_zumArtist_clicked(self, ev):
        url = self.ArtistLabels['url'].get_label()
        webbrowser.open( url )

    def scrolled_window_resize(self, obj, gdkrect):
        self.scrolledwindow_width = gdkrect[2]
        self.scrolledwindow_height = gdkrect[3]
        if self.main.allow_rearrange and self.main.layout_mode=="top":
            self.main.allow_rearrange = False
            self.main.arrange_topoftheweek()
            gobject.timeout_add(200, self.main.set_allow_rearrange)
        elif self.main.allow_rearrange and self.main.layout_mode=="artist":
            self.main.allow_rearrange = False
            self.main.arrange_artistdetail()
            gobject.timeout_add(200, self.main.set_allow_rearrange)

    def cbOrder_changed(self, ev1=None):
        mode = self.get_active_text(self.cbOrder)
        self.main.ordering = mode
        self.main.clear_layout("top", self.main.results_per_page, mode, 1, self.main.tag)

    def cbResultsPerPage_changed(self, ev1=None):
        self.main.results_per_page = int(self.get_active_text(self.cbResultsPerPage))
        self.main.clear_layout("top", self.main.results_per_page, self.main.ordering, 1, self.main.tag, who_called = "cbResultsPerPage_changed")
        #print self.results_per_page

    def cbTags_key_press_event(self, ev1, ev2=None):
        print "KEYPRESS"

    def cbTags_changed(self, ev1=None):
        tag = self.get_active_text(self.cbTags)
        print self.cbTags.get_active_text()
        self.main.tag = tag
        self.main.clear_layout("top", self.main.results_per_page, self.main.ordering, 1, tag, who_called = "cbTags_changed")        

    def get_active_text(self, combobox):
        model = combobox.get_model()
        active = combobox.get_active()
        if active < 0:
            return None
        return model[active][0]
        ## => active = combobox.get_active()

    def setStatus(self, text=""):
        self.message_id = self.sbStatus.push(self.context_id, text)

    def quit(self, widget, event ):
        self.iconify()
        return True
#        return None

    def really_quit(self, ev=None):
        if self.main.verbose:
            print "##########################################################"
            print _("Query Session Statistics:")
            print _("Cached Queries: %i") % self.main.jamendo.cache_counter
            print _("Jamendo Queries: %i") % self.main.jamendo.jamendo_counter
            print "##########################################################"
            print _("Total Cache Statistics:")
            os.system("du -h %s" % os.path.join(functions.preparedirs(), "cache")) 
            print "##########################################################"
            print _("Cached Queries Total:")
            os.system("du -a %s|wc -l" % os.path.join(functions.preparedirs(), "cache")) 
            print "##########################################################"
            print _("Stored Images:")
            os.system("du -a %s|wc -l" % os.path.join(functions.preparedirs(), "images")) 
            print "##########################################################"
            print _("Stored Images Size:")
            os.system("du -h %s" % os.path.join(functions.preparedirs(), "images")) 
            print "##########################################################"
        self.main.player.stop()
        gtk.main_quit()

    def on_bHome_clicked(self, ev):
        self.main.clear_layout("top", 10, "ratingweek", 1, who_called = "on_bHome_clicked")


    def on_button_clicked(self, ev):
        #print self.albuminfos[0].album['album_id']
        #print self.scrolledwindow_width
        #self.arrange_topoftheweek()
        self.main.clear_layout("top", 99, "date", 2, who_called = "on_button_clicked")

    def on_sbVolume_Change(self, range, scroll, value):
        value = int(value)
        if value > VOL_MAX: value = VOL_MAX
        if value < 0: value = 0
        self.main.player.set_volume(value)

    def __setcolor(self, widget):
        if self.main.nocolor:
            return None 
        style = widget.get_style()
        color = widget.get_colormap()
        bg = color.alloc_color(self.bgcolor)#(20000,20000,65000,0)
        fg = color.alloc_color(0, 0, 0, 0)
        style.bg[gtk.STATE_NORMAL] = bg
        style.fg[gtk.STATE_NORMAL] = fg
        widget.set_style(style)

def sorteddirlist():
    dirs = os.listdir(os.path.join(functions.preparedirs(),"themes", ""))
    dirs_list = []
    for counter in xrange(0, len(dirs)):
        dirs_list.append(dirs[counter])
    return sorted(dirs_list)

def showtheme(theme):
    #if theme == os.path.join(functions.install_dir(), "themes", STANDARD_THEME, "gtk-2.0", "gtkrc"):
    if STANDARD_THEME in theme:
        return gtk.rc_parse(theme), STANDARD_THEME
    home = functions.preparedirs()
    if theme.isdigit():
        dirs = sorteddirlist()
        if int(theme)-1 < len(dirs):
           theme = dirs[int(theme)-1]
        else:
           return _("No theme for entry '%s'") % theme, None
    fl = os.path.join(home, "themes", theme, "gtk-2.0", "gtkrc")
    try:
       f = open( fl )
    except:
       return _("Error reading the theme file '%s'") % fl, None
    f.close()
    return gtk.rc_parse(fl), theme
     
def run(options):
    home = functions.preparedirs()
    if "check-modules" in sys.argv:
        functions.check_modules()        
        return None
    if options.cache_long:
        directory = os.path.join(home, "cache", "long")
        files = os.listdir(directory)
        for f in files:
            os.remove(os.path.join(directory, f))
        print _("Deleted all cache-entries for long-time-cache")
    if options.cache_short:
        directory = os.path.join(home, "cache", "short")
        files = os.listdir(directory)
        for f in files:
            os.remove(os.path.join(directory, f))
        print _("Deleted all cache-entries for short-time-cache")
#    if len(sorteddirlist()) == 0:
#        options.downloadthemes = True
    if options.downloadthemes:
        # IMPROVE THIS
        import get_themepack 
        ret = get_themepack.download_pack()    
        if ret == 0:
            #pass
            options.listhemes = True
        else:
            return None
    if options.downloadimages:
        # IMPROVE THIS
        import get_imagepack 
        ret = get_imagepack.download_pack()        
        if ret == 0:
            # no error
            pass
        else:
            print _("An error occured")
            print _("You can try again running 'pyjama -i'")
    if not os.path.exists(os.path.join(home, "pyjama.db")) and not options.update:
        print _("Downloading Database")
        options.update = True
    if options.update:
        # FIX THIS PART!
        try:
            import download_db as update
        except:
            print _("Error importing update module")
        update.delete_db()
        update.create_tables()
        update.create_db()
    if options.listhemes:
        dirs = sorteddirlist()
        counter = 1
        if len(dirs) == 0:
            print _("No themes installed")
            print _("You can get some by running 'pyjama -p'")
        else:
            print _("Following Themes were found:")
        for directory in dirs:
            print "%i) %s" % (counter, directory)
            counter += 1
        return None
    if not options.nocolor and not options.theme:
        standard_theme_tmp1 = os.path.join(functions.install_dir(), "themes", STANDARD_THEME, "gtk-2.0", "gtkrc")
        standard_theme_tmp2 = os.path.join(home, "themes", STANDARD_THEME, "gtk-2.0", "gtkrc")
        if os.path.exists(standard_theme_tmp1): options.theme = standard_theme_tmp1
        if os.path.exists(standard_theme_tmp2): options.theme = standard_theme_tmp2     
    if options.theme and not options.nocolor:
        ret, theme = showtheme(options.theme)
        if ret == None:
            print _("Loaded theme '%s'") % theme
        else:
            print ret
            return None
    winGTK(options)
    gtk.main()

if __name__ == "__main__":
    parser = OptionParser()

    parser.add_option("-t", "--theme", dest="theme", help=_("A gtk theme for pyjama. The theme as to be copied to '~/.pyjama/themes'. Example: pyjama --theme Aero-ion3.1. pyjama -t 1 would run the first theme found in your theme- directory."), metavar="theme")

    parser.add_option("-l", "--list", action="store_true", dest="listhemes", default=False, help=_("List all themes found"))

    parser.add_option("-p", "--download-themes", action="store_true", dest="downloadthemes", default=False, help=_("Download Themepack for Pyjama"))

    parser.add_option("-i", "--download-images", action="store_true", dest="downloadimages", default=False, help=_("Downloads round about 4MB of album covers from a mirror to speed up browsing through jamendo - this is usually done on the first run automatically"))

    parser.add_option("-n", "--notheme", action="store_true", dest="nocolor", default=False, help=_("Don't do any color- modifications. Pyjama will exactly look like any of your applications"))

    parser.add_option("-u", "--update", action="store_true", dest="update", default=False, help=_("Get Jamendo's latest database dump"))

    parser.add_option("", "--clear-short", action="store_true", dest="cache_short", default=False, help="Delete local cache data (short)")

    parser.add_option("", "--clear-long", action="store_true", dest="cache_long", default=False, help="Delete local cache data (long)")

    parser.add_option("-v", "--verbose", action="store_true", dest="verbose", default=False, help=_("Print some informations"))

    parser.add_option("-d", "--debug", action="store_true", dest="debug", default=False, help=_("Print a lot informations"))

    parser.add_option("-e", "--debug-extreme", action="store_true", dest="debug_extreme", default=False, help=_("Print much to much information"))
    


    (options, args) = parser.parse_args()
    run(options)

#run = winTk()
